#ifdef HAVE_CONFIG_H
#  include <config.h>
#endif

#include <gtk/gtk.h>

#include "callbacks.h"
#include "interface.h"
#include "support.h"

#include "gameutils.h"
#include "moteur.h"
#include "deepblue.h"

#include <libintl.h>
#define _(x)  gettext(x)

void sendCoords (Coords clickedCell);
void drawPlateau();

void 
on_about_activate(GtkWidget       *window,
		  gpointer         user_data)
{
  GtkAboutDialog *about = GTK_ABOUT_DIALOG(gtk_about_dialog_new());

  gtk_about_dialog_set_name(about, "Othello");
  gtk_about_dialog_set_version(about, VERSION);
  gtk_about_dialog_set_copyright(about, 
	 "Maemo Othello port (c) 2007 by\n" 
	       "Till Harbaum <till@harbaum.org>\n"
	 "GPE-Othello port (c) 2007 by\n"
	       "Joseph J. McCarthy <mccarthy@granular.che.pitt.edu>\n"
	 "Ultimate othello 1666 (c) 1999 by\n"
	       "Florent Boudet <flobo@ios-software.com>\n"
	       "Jean Christophe Hoelt <jeko@ios-software.com>");

  gtk_about_dialog_set_website(about,
       "http://othello.garage.maemo.org");
  
  gtk_about_dialog_set_comments(about, 
       "The classic game of Othello/Reversi");

  gtk_widget_show_all(GTK_WIDGET(about));
  gtk_dialog_run(GTK_DIALOG(about));
  gtk_widget_destroy(GTK_WIDGET(about));
}

void
on_new_game1_activate                  (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{
    Coords nullCoords;

    nullCoords.h = 0;
    nullCoords.v = 0;

    coulact = blanc;
    initTableau();

    sendCoords(nullCoords);
    drawPlateau();
}


void
on_quitter_activate                    (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{
	gtk_main_quit();
}

void
on_novice1_activate                    (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{
  if(gtk_toggle_button_get_active((GtkToggleButton*)menuitem)) 
    depth = 1;
}


void
on_easy1_activate                      (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{
  if(gtk_toggle_button_get_active((GtkToggleButton*)menuitem)) 
    depth = 3;
}


void
on_medium1_activate                    (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{
  if(gtk_toggle_button_get_active((GtkToggleButton*)menuitem)) 
    printf("setting depth 4\n");
}


void
on_good1_activate                      (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{
  if(gtk_toggle_button_get_active((GtkToggleButton*)menuitem)) 
    printf("setting depth 5\n");
}
