/*
 * main.c initial gnr par Glade. Editer ce fichier  votre
 * convenance. Glade n'crira plus dans ce fichier.
 */

#ifdef HAVE_CONFIG_H
#  include <config.h>
#endif

#include <hildon/hildon-program.h>

#include <gtk/gtkmain.h>
#include <gtk/gtklabel.h>

//#include <pthread.h>
#include <gtk/gtk.h>
#include <stdlib.h>
#include <stdio.h>
#include <string.h>

#include <unistd.h>

#include <libintl.h>

#define _(x)  gettext(x)

#include "callbacks.h"
#include "interface.h"
#include "support.h"

#include "moteur.h"
#include "gameutils.h"

#define ANIM_INTERVAL 60

GdkPixmap *cells[13];
GdkBitmap *cells_mask[13];

static GtkWidget *pref_dialog;

GtkWidget *table[8][8];
int grilleAffichage[8][8];
short depth, old_depth;

GtkStatusbar *status;
guint status_cid;

GtkLabel *l_white,*l_black;

static int bouge = 0;
static Coords nullCoords = {0,0};

void smsg(const char *msg) {
  static guint mid = 0;
  if(mid)
    gtk_statusbar_pop(status,status_cid);
  
  mid = gtk_statusbar_push(status,status_cid,msg);
}

void drawPlateau();
void initPlateau(GtkWidget *win);
gboolean on_cell_button_press_event(GtkWidget       *widget,
				    GdkEventButton  *event,
				    gpointer         user_data);

int moteurResult = 0;

int gameIteration(gpointer inutile) {
  if(!bouge) {
    if(moteurResult == 3) {
      /* Fin du jeu */
      smsg("End of game");
    }
    else if(moteurResult != 0) {
      short playingColor;
      
      bouge = 1;
      playingColor = coulact;
      moteurResult = Moteur(nullCoords);
      if(abs(moteurResult) == 1) {
	if(moteurResult == blanc)
	  smsg("White must skip a turn");
	if(moteurResult == noir)
	  smsg("Black must skip a turn");
      }
      else if(moteurResult == 2) {
	char s[255];
	sprintf(s,"%s plays", coulact==noir?"Black":"White");
	smsg(s);
      }
      // FAIRE UNE PAUSE POUR GTK..(genre 1 sec)
			//	while(bouge) {
			//		usleep(ANIM_INTERVAL*1000);
			//	}
      drawPlateau();
    }
  }
  return 1;
}

void sendCoords(Coords clickedCell)
{
  if(!bouge) {
    short playingColor;
    
    if((canPlay(clickedCell, coulact)) ||(clickedCell.h == 0)) {
      bouge = 1;
      playingColor = coulact;
      moteurResult = Moteur(clickedCell);
      if(moteurResult == 2) {
	char s[255];
	sprintf(s,"%s plays", coulact==noir?"Black":"White");
	smsg(s);
	drawPlateau();
      }
    } else {
      char s[255];
      sprintf(s,"Invalid move... %s plays", coulact==noir?"Black":"White");
      smsg(s);
    }
  }
}

void initPlateau(GtkWidget *win) {
  int h,v, i;
  GtkWidget *gtable;
  gtable = gtk_object_get_data(GTK_OBJECT(win),"game_table");
  
  gtk_pixmap_get(GTK_PIXMAP(gtk_object_get_data(GTK_OBJECT(win), "blackcell")),
		 &cells[12], &cells_mask[12]);
  gtk_pixmap_get(GTK_PIXMAP(gtk_object_get_data(GTK_OBJECT(win), "whitecell")),
		 &cells[1], &cells_mask[1]);
  gtk_pixmap_get(GTK_PIXMAP(gtk_object_get_data(GTK_OBJECT(win), "emptycell")),
		 &cells[0], &cells_mask[0]);
  
  for(i=1;i<=10;i++) {
    char name[8];
    sprintf(name, "anim%02d", i);
  
    gtk_pixmap_get(GTK_PIXMAP(gtk_object_get_data(GTK_OBJECT(win), name)),
		   &cells[i+1], &cells_mask[i+1]);
  }

  for(h=0;h<8;h++) {
    for(v=0;v<8;v++) {
      table[h][v] = gtk_pixmap_new(cells[0], cells_mask[0]);
      gtk_widget_show(table[h][v]);
    }
  }

  smsg("White begins");
}

int animatePlateau(gpointer inutile) {
  int h,v;
  int encore = 0;
  for(h=1;h<=8;h++)
    for(v=1;v<=8;v++) {
      int changed = 0;
      
      if(tableau[h][v] == noir) {
	changed = 1;
	if(grilleAffichage[h-1][v-1] == 0)
	  grilleAffichage[h-1][v-1] = 12;
	else if(grilleAffichage[h-1][v-1] < 12)
	  grilleAffichage[h-1][v-1] ++;
	else
	  changed = 0;
      }
      
      if(tableau[h][v] == blanc) {
	changed = 1;
	if(grilleAffichage[h-1][v-1] == 0)
	  grilleAffichage[h-1][v-1] = 1;
	else if(grilleAffichage[h-1][v-1] > 1)
	  grilleAffichage[h-1][v-1] --;
	else
	  changed = 0;
      }
      
      if((tableau[h][v] == vide) &&(grilleAffichage[h-1][v-1] != 0)) {
	changed = 1;
	grilleAffichage[h-1][v-1] = 0;
      }
      
      if(changed) {
	gtk_pixmap_set(GTK_PIXMAP(table[h-1][v-1]),
		       cells[grilleAffichage[h-1][v-1]],
		       cells_mask[grilleAffichage[h-1][v-1]]);
	encore ++;
      }
    }
  
  if(encore) {
    bouge = 1;
  }
  else {
    bouge = 0;
  }
  return 1;
}

void drawPlateau() {
  int h;
  char tmp[255];
  
  h = compter(noir);
  if(h > 1)
    sprintf(tmp, "%d cells", h);
  else if(h==0)
    strcpy(tmp, "No cells");
  else if(h==1)
    strcpy(tmp, "1 cell");
  gtk_label_set_text(l_black, tmp);
  
  h = compter(blanc);
  if(h > 1)
    sprintf(tmp, "%d cells", h);
  else if(h==0)
    strcpy(tmp, "No cells");
  else if(h==1)
    strcpy(tmp, "1 cell");
  gtk_label_set_text(l_white, tmp);
}

gboolean
on_cell_button_press_event(GtkWidget       *widget,
			   GdkEventButton  *event,
			   gpointer         user_data) {
  Coords *coords =(Coords*)user_data;
  sendCoords(*coords);
  return FALSE;
}

static void
pref_cancel(GtkWidget *widget, void *data)
{
  depth = old_depth;  /* restore previous depth */
  gtk_widget_destroy(pref_dialog);
  pref_dialog = 0;
}

static void
pref_apply(GtkWidget *widget, void *data)
{
  Coords nullCoords;

  old_depth = depth;
  gtk_widget_destroy(pref_dialog);
  pref_dialog = 0;
  
  nullCoords.h = 0;
  nullCoords.v = 0;

  coulact = blanc;
  initTableau();

  sendCoords(nullCoords);
  drawPlateau();
}

static void
prefs(void) {
  GtkWidget *frame, *vbox, *button;
  GtkWidget *ok, *cancel;
  
  if(pref_dialog)
    return;
  
  pref_dialog = gtk_dialog_new();

  gtk_window_set_title(GTK_WINDOW(pref_dialog), _("Preferences"));

  gtk_widget_realize(pref_dialog);

  ok = gtk_button_new_with_label(_("Ok"));
  cancel = gtk_button_new_with_label(_("Cancel"));

  gtk_signal_connect(GTK_OBJECT(pref_dialog), "delete_event", 
		     (GtkSignalFunc)pref_cancel, NULL);

  frame = gtk_frame_new(_("Difficulty"));
  gtk_container_set_border_width(GTK_CONTAINER(frame), 5);
  gtk_widget_show(frame);
  vbox = gtk_vbox_new(TRUE, 0);
  gtk_container_set_border_width(GTK_CONTAINER(vbox), 5);
  gtk_widget_show(vbox);

  old_depth = depth;

  button = gtk_radio_button_new_with_label(NULL, "Novice");
  if(depth == 1)
    gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(button), TRUE);
  gtk_signal_connect(GTK_OBJECT(button), "toggled",
		     GTK_SIGNAL_FUNC(on_novice1_activate), NULL);
  gtk_box_pack_start(GTK_BOX(vbox), button, FALSE, FALSE, 0);
  gtk_widget_show(button);

  button = gtk_radio_button_new_with_label
   (gtk_radio_button_group(GTK_RADIO_BUTTON(button)), "Easy");
  if(depth == 3)
    gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(button), TRUE);
  gtk_signal_connect(GTK_OBJECT(button), "toggled",
		      GTK_SIGNAL_FUNC(on_easy1_activate), NULL);
  gtk_box_pack_start(GTK_BOX(vbox), button, FALSE, FALSE, 0);
  gtk_widget_show(button);

  button = gtk_radio_button_new_with_label
   (gtk_radio_button_group(GTK_RADIO_BUTTON(button)), "Medium");
  if(depth == 4)
    gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(button), TRUE);
  gtk_signal_connect(GTK_OBJECT(button), "toggled",
		      GTK_SIGNAL_FUNC(on_medium1_activate), NULL);
  gtk_box_pack_start(GTK_BOX(vbox), button, FALSE, FALSE, 0);
  gtk_widget_show(button);

  button = gtk_radio_button_new_with_label
   (gtk_radio_button_group(GTK_RADIO_BUTTON(button)), "Difficult");
  if(depth == 5)
    gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(button), TRUE);
  gtk_signal_connect(GTK_OBJECT(button), "toggled",
		      GTK_SIGNAL_FUNC(on_good1_activate), NULL);
  gtk_box_pack_start(GTK_BOX(vbox), button, FALSE, FALSE, 0);
  gtk_widget_show(button);

  gtk_container_add(GTK_CONTAINER(frame), vbox);
  gtk_box_pack_start_defaults(GTK_BOX(GTK_DIALOG(pref_dialog)->vbox), frame);

  gtk_widget_show(ok);
  gtk_widget_show(cancel);
  
  gtk_box_pack_start(GTK_BOX(GTK_DIALOG(pref_dialog)->action_area), 
		     ok, TRUE, TRUE, 0);
  gtk_box_pack_start(GTK_BOX(GTK_DIALOG(pref_dialog)->action_area), 
		     cancel, TRUE, TRUE, 0);
  
  gtk_signal_connect(GTK_OBJECT(ok), "clicked", 
		     GTK_SIGNAL_FUNC(pref_apply), NULL);
  gtk_signal_connect(GTK_OBJECT(cancel), "clicked", 
		     GTK_SIGNAL_FUNC(pref_cancel), NULL);

  gtk_widget_show(pref_dialog);

}

int
main(int argc, char *argv[])
{
  int x,y,i;
  HildonProgram *program;
  HildonWindow *window;
  GtkWidget *vbox1;
  GtkWidget *align;
  GtkWidget *menu, *item;
  GtkWidget *hbox1;
  GtkWidget *game_table;
  GtkWidget *eventbox_emptycell;
  GtkWidget *emptycell;
  GtkWidget *anim;
  GtkWidget *table2;
  GtkWidget *hseparator1;
  GtkWidget *hseparator2;
  GtkWidget *hseparator3;
  GtkWidget *whitecell;
  GtkWidget *blackcell;
  GtkWidget *label_white_point;
  GtkWidget *label_black_point;
  GtkWidget *statusbar1;

  /* Initialize the GTK. */
  gtk_init(&argc, &argv);

  /* Create the hildon program and setup the title */
  program = HILDON_PROGRAM(hildon_program_get_instance());
  g_set_application_name( _("Othello") );

  /* Create HildonWindow and set it to HildonProgram */
  window = HILDON_WINDOW(hildon_window_new());
  hildon_program_add_window(program, window);

  /* Initialize the locale stuff */
  setlocale ( LC_ALL, "" );
  bindtextdomain ( PACKAGE, LOCALEDIR );
  bind_textdomain_codeset( PACKAGE, "UTF-8");
  textdomain( PACKAGE );

  add_pixmap_directory(PREFIX "/share/" PACKAGE);
  add_pixmap_directory("./pixmaps");

  jblordi = 1;
  jnoordi = 0;
  initOthello();
  
  for(x=0;x<8;x++) for(y=0;y<8;y++) grilleAffichage[x][y] = 0;
  
  gtk_signal_connect(GTK_OBJECT(window), "delete_event",
		      GTK_SIGNAL_FUNC(on_quitter_activate),
		      NULL);
  
  vbox1 = gtk_vbox_new(FALSE, 0);
  gtk_container_add(GTK_CONTAINER(window), vbox1);

  /*********************** build menubar *********************/

  menu = gtk_menu_new();

  item = gtk_menu_item_new_with_label( _("About") );
  gtk_menu_append(GTK_MENU_SHELL(menu), item);
  g_signal_connect_swapped(item,"activate", 
		   GTK_SIGNAL_FUNC(on_about_activate), window);

  gtk_menu_append(GTK_MENU_SHELL(menu), gtk_separator_menu_item_new());

  item = gtk_menu_item_new_with_label( _("New Game") );
  gtk_menu_append(GTK_MENU_SHELL(menu), item);
  g_signal_connect_swapped(item,"activate", 
		   GTK_SIGNAL_FUNC(on_new_game1_activate), NULL);

  item = gtk_menu_item_new_with_label( _("Preferences") );
  gtk_menu_append(GTK_MENU_SHELL(menu), item);
  g_signal_connect_swapped(item,"activate", 
		   GTK_SIGNAL_FUNC(prefs), NULL);

  gtk_menu_append(GTK_MENU_SHELL(menu), gtk_separator_menu_item_new());

  item = gtk_menu_item_new_with_label( _("Exit") );
  gtk_menu_append(GTK_MENU_SHELL(menu), item);
  g_signal_connect_swapped(item,"activate", 
		   GTK_SIGNAL_FUNC(on_quitter_activate), NULL);

  hildon_window_set_menu(HILDON_WINDOW(window), GTK_MENU(menu));


  gtk_widget_realize((GtkWidget*)window);

  align = gtk_alignment_new(0.5, 0.5, 0.0, 0.0);
  gtk_box_pack_start(GTK_BOX(vbox1), align, TRUE, TRUE, 0);
  
  hbox1 = gtk_hbox_new(FALSE, 0);
  gtk_widget_set_name(hbox1, "hbox1");
  gtk_widget_ref(hbox1);
  gtk_object_set_data_full(GTK_OBJECT(window), "hbox1", hbox1,
                           (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show(hbox1);
  gtk_box_pack_start(GTK_BOX(vbox1), hbox1, TRUE, TRUE, 0);

  game_table = gtk_table_new(8, 8, TRUE);
  gtk_widget_set_name(game_table, "game_table");
  gtk_widget_ref(game_table);
  gtk_object_set_data_full(GTK_OBJECT(window), "game_table", game_table,
                           (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show(game_table);
  gtk_box_pack_start(GTK_BOX(hbox1), game_table, FALSE, FALSE, 0);
  //  gtk_widget_set_usize(game_table, 170, 170);
  gtk_container_set_border_width(GTK_CONTAINER(game_table), 21);

  eventbox_emptycell = gtk_event_box_new();
  gtk_widget_set_name(eventbox_emptycell, "eventbox_emptycell");
  gtk_widget_ref(eventbox_emptycell);
  gtk_object_set_data_full(GTK_OBJECT(window), "eventbox_emptycell", 
			   eventbox_emptycell,
                           (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show(eventbox_emptycell);
  gtk_table_attach(GTK_TABLE(game_table), eventbox_emptycell, 0, 1, 0, 1,
                   (GtkAttachOptions)(GTK_EXPAND | GTK_FILL),
                   (GtkAttachOptions)(GTK_EXPAND | GTK_FILL), 0, 0);

  emptycell = create_pixmap((GtkWidget*)window, "EmptyCell.xpm");
  gtk_widget_set_name(emptycell, "emptycell");
  gtk_widget_ref(emptycell);
  gtk_object_set_data_full(GTK_OBJECT(window), "emptycell", emptycell,
                           (GtkDestroyNotify) gtk_widget_unref);
  gtk_container_add(GTK_CONTAINER(eventbox_emptycell), emptycell);

  for(i=1;i<=10;i++) {
    char filename[8], widget_name[8];

    sprintf(filename, "%02d.xpm", i);
    sprintf(widget_name, "anim%02d", i);

    anim = create_pixmap((GtkWidget*)window, filename);
    gtk_widget_set_name(anim, widget_name);
    gtk_widget_ref(anim);
    gtk_object_set_data_full(GTK_OBJECT(window), widget_name, anim,
			     (GtkDestroyNotify) gtk_widget_unref);
  }

  table2 = gtk_table_new(5, 2, FALSE);
  gtk_container_set_border_width(GTK_CONTAINER(table2), 21);
  gtk_widget_set_name(table2, "table2");
  gtk_widget_ref(table2);
  gtk_object_set_data_full(GTK_OBJECT(window), "table2", table2,
                           (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show(table2);
  gtk_box_pack_start(GTK_BOX(hbox1), table2, TRUE, TRUE, 0);

  hseparator1 = gtk_hseparator_new();
  gtk_widget_set_name(hseparator1, "hseparator1");
  gtk_widget_ref(hseparator1);
  gtk_object_set_data_full(GTK_OBJECT(window), "hseparator1", hseparator1,
                           (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show(hseparator1);
  gtk_table_attach(GTK_TABLE(table2), hseparator1, 0, 2, 2, 3,
                   (GtkAttachOptions)(GTK_FILL),
                   (GtkAttachOptions)(GTK_FILL), 0, 0);

  hseparator2 = gtk_hseparator_new();
  gtk_widget_set_name(hseparator2, "hseparator2");
  gtk_widget_ref(hseparator2);
  gtk_object_set_data_full(GTK_OBJECT(window), "hseparator2", hseparator2,
                           (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show(hseparator2);
  gtk_table_attach(GTK_TABLE(table2), hseparator2, 0, 2, 0, 1,
                   (GtkAttachOptions)(GTK_FILL),
                   (GtkAttachOptions)(GTK_FILL), 0, 0);

  hseparator3 = gtk_hseparator_new();
  gtk_widget_set_name(hseparator3, "hseparator3");
  gtk_widget_ref(hseparator3);
  gtk_object_set_data_full(GTK_OBJECT(window), "hseparator3", hseparator3,
                           (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show(hseparator3);
  gtk_table_attach(GTK_TABLE(table2), hseparator3, 0, 2, 4, 5,
                   (GtkAttachOptions)(GTK_FILL),
                   (GtkAttachOptions)(GTK_FILL), 0, 0);

  whitecell = create_pixmap((GtkWidget*)window, "WhiteCell.xpm");
  gtk_widget_set_name(whitecell, "whitecell");
  gtk_widget_ref(whitecell);
  gtk_object_set_data_full(GTK_OBJECT(window), "whitecell", whitecell,
                           (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show(whitecell);
  gtk_table_attach(GTK_TABLE(table2), whitecell, 0, 1, 1, 2,
                   (GtkAttachOptions)(GTK_FILL),
		   (GtkAttachOptions)(GTK_FILL), 1, 0);
  gtk_misc_set_alignment(GTK_MISC(whitecell), 0, 0.5);

  blackcell = create_pixmap((GtkWidget*)window, "BlackCell.xpm");
  gtk_widget_set_name(blackcell, "blackcell");
  gtk_widget_ref(blackcell);
  gtk_object_set_data_full(GTK_OBJECT(window), "blackcell", blackcell,
                           (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show(blackcell);
  gtk_table_attach(GTK_TABLE(table2), blackcell, 0, 1, 3, 4,
                   (GtkAttachOptions)(GTK_FILL),
                   (GtkAttachOptions)(GTK_FILL), 1, 0);

  label_white_point = gtk_label_new("No cells");
  gtk_widget_set_name(label_white_point, "label_white_point");
  gtk_widget_ref(label_white_point);
  gtk_object_set_data_full(GTK_OBJECT(window), "label_white_point", label_white_point,
                           (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show(label_white_point);
  gtk_table_attach(GTK_TABLE(table2), label_white_point, 1, 2, 1, 2,
                   (GtkAttachOptions)(GTK_EXPAND),
                   (GtkAttachOptions)(0), 1, 0);

  label_black_point = gtk_label_new("No cells");
  gtk_widget_set_name(label_black_point, "label_black_point");
  gtk_widget_ref(label_black_point);
  gtk_object_set_data_full(GTK_OBJECT(window), "label_black_point", label_black_point,
                           (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show(label_black_point);
  gtk_table_attach(GTK_TABLE(table2), label_black_point, 1, 2, 3, 4,
                   (GtkAttachOptions)(GTK_EXPAND),
                   (GtkAttachOptions)(0), 0, 0);
  
  statusbar1 = gtk_statusbar_new();
  gtk_widget_set_name(statusbar1, "statusbar1");
  gtk_widget_ref(statusbar1);
  gtk_object_set_data_full(GTK_OBJECT(window), "statusbar1", statusbar1,
                           (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show(statusbar1);
  gtk_box_pack_start(GTK_BOX(vbox1), statusbar1, FALSE, FALSE, 0);

  gtk_signal_connect(GTK_OBJECT(window), "delete_event",
                      GTK_SIGNAL_FUNC(on_quitter_activate),
                      NULL);
  gtk_signal_connect(GTK_OBJECT(window), "destroy_event",
                      GTK_SIGNAL_FUNC(on_quitter_activate),
                      NULL);
 
  gtk_widget_show_all((GtkWidget*)window);

  l_black = GTK_LABEL(gtk_object_get_data(GTK_OBJECT(window),
					  "label_black_point"));
  l_white = GTK_LABEL(gtk_object_get_data(GTK_OBJECT(window),
					  "label_white_point"));
  
  status = GTK_STATUSBAR(gtk_object_get_data(GTK_OBJECT(window),"statusbar1"));
  status_cid = gtk_statusbar_get_context_id(status, "Ptits messages");

  initPlateau((GtkWidget*)window);

  for(x=0;x<8;x++)
    for(y=0;y<8;y++) {
      GtkWidget *eventbox;
      Coords *coords;
      
      eventbox = gtk_event_box_new();
      gtk_widget_show(eventbox);
      
      gtk_table_attach(GTK_TABLE(game_table),
			eventbox,
			x,x+1,y,y+1,
			(GtkAttachOptions)(GTK_FILL),
			(GtkAttachOptions)(GTK_FILL),
			0, 0);
      
      gtk_container_add(GTK_CONTAINER(eventbox),table[x][y]);

      coords =(Coords*)malloc(sizeof(Coords));
      coords->h = x+1;
      coords->v = y+1;
      
      gtk_signal_connect(GTK_OBJECT(eventbox), "button_press_event",
			  GTK_SIGNAL_FUNC(on_cell_button_press_event),
			 (void*)coords);
    }
  


  drawPlateau();

  gtk_timeout_add(ANIM_INTERVAL,animatePlateau, NULL);
  gtk_timeout_add(ANIM_INTERVAL*5,gameIteration, NULL);

  gtk_main();
  return 0;
}

